package dev.shadowsoffire.apotheosis.ench.table;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.mojang.blaze3d.vertex.PoseStack;
import dev.shadowsoffire.apotheosis.ench.EnchModule;
import dev.shadowsoffire.apotheosis.ench.table.ApothEnchantScreen;
import dev.shadowsoffire.apotheosis.ench.table.ApothEnchantmentMenu;
import dev.shadowsoffire.apotheosis.ench.table.EnchantingStatRegistry;
import dev.shadowsoffire.apotheosis.ench.table.RealEnchantmentHelper;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Locale;
import java.util.Map;
import java.util.Set;
import java.util.stream.Collectors;
import net.minecraft.ChatFormatting;
import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.GuiGraphics;
import net.minecraft.client.gui.components.events.GuiEventListener;
import net.minecraft.client.gui.screens.Screen;
import net.minecraft.client.resources.language.I18n;
import net.minecraft.client.resources.sounds.SimpleSoundInstance;
import net.minecraft.client.resources.sounds.SoundInstance;
import net.minecraft.core.Holder;
import net.minecraft.network.chat.Component;
import net.minecraft.network.chat.MutableComponent;
import net.minecraft.network.chat.Style;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.sounds.SoundEvents;
import net.minecraft.util.Mth;
import net.minecraft.util.random.WeightedRandom;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.enchantment.Enchantment;
import net.minecraft.world.item.enchantment.EnchantmentInstance;

public class EnchantingInfoScreen extends Screen {
  public static final ResourceLocation TEXTURES = new ResourceLocation("apotheosis", "textures/gui/enchanting_info.png");
  
  protected static ChatFormatting[] colors = new ChatFormatting[] { ChatFormatting.WHITE, ChatFormatting.YELLOW, ChatFormatting.BLUE, ChatFormatting.GOLD };
  
  protected final ApothEnchantScreen parent;
  
  protected final int imageWidth;
  
  protected final int imageHeight;
  
  protected final ItemStack toEnchant;
  
  protected final int[] costs;
  
  protected final int[] clues;
  
  protected final int[][] powers = new int[3][];
  
  protected final boolean treasure;
  
  protected int selectedSlot = -1;
  
  protected int leftPos;
  
  protected int topPos;
  
  protected PowerSlider slider;
  
  protected int currentPower;
  
  protected float scrollOffs;
  
  protected boolean scrolling;
  
  protected int startIndex;
  
  List<EnchantmentDataWrapper> enchantments = Collections.emptyList();
  
  Map<Enchantment, List<Enchantment>> exclusions = new HashMap<>();
  
  public EnchantingInfoScreen(ApothEnchantScreen parent) {
    super((Component)Component.m_237115_("info.apotheosis.enchinfo_title"));
    this.parent = parent;
    this.imageWidth = 240;
    this.imageHeight = 170;
    this.toEnchant = parent.getMenu().m_38853_(0).m_7993_();
    this.costs = (parent.getMenu()).f_39446_;
    this.clues = (parent.getMenu()).f_39447_;
    this.treasure = (parent.getMenu()).stats.treasure();
    for (int i = 0; i < 3; i++) {
      Enchantment clue = Enchantment.m_44697_(this.clues[i]);
      if (clue != null) {
        int level = this.costs[i];
        float quanta = (parent.getMenu()).stats.quanta() / 100.0F;
        float rectification = (parent.getMenu()).stats.rectification() / 100.0F;
        int minPow = Math.round(Mth.m_14036_(level - level * (quanta - quanta * rectification), 1.0F, EnchantingStatRegistry.getAbsoluteMaxEterna() * 4.0F));
        int maxPow = Math.round(Mth.m_14036_(level + level * quanta, 1.0F, EnchantingStatRegistry.getAbsoluteMaxEterna() * 4.0F));
        (new int[2])[0] = minPow;
        (new int[2])[1] = maxPow;
        this.powers[i] = new int[2];
        this.selectedSlot = i;
      } 
    } 
  }
  
  protected void m_7856_() {
    this.leftPos = (this.f_96543_ - this.imageWidth) / 2;
    this.topPos = (this.f_96544_ - this.imageHeight) / 2;
    this.slider = (PowerSlider)m_142416_((GuiEventListener)new PowerSlider(this, this.leftPos + 5, this.topPos + 80, 80, 20));
  }
  
  public void m_88315_(GuiGraphics gfx, int pMouseX, int pMouseY, float pPartialTick) {
    m_280273_(gfx);
    PoseStack pose = gfx.m_280168_();
    pose.m_85836_();
    pose.m_252880_(this.leftPos, this.topPos, 0.0F);
    gfx.m_280218_(TEXTURES, 0, 0, 0, 0, this.imageWidth, this.imageHeight);
    for (int i = 0; i < 3; i++) {
      Enchantment clue = Enchantment.m_44697_(this.clues[i]);
      int u = 199, v = 225;
      if (clue == null) {
        u += 19;
        v += 16;
      } else if (this.selectedSlot == i || isHovering(8, 18 + 19 * i, 18, 18, pMouseX, pMouseY)) {
        u += 38;
      } 
      gfx.m_280218_(TEXTURES, 8, 18 + 19 * i, 224, u, 18, 19);
      gfx.m_280218_(TEXTURES, 9, 22 + 18 * i + i, 16 * i, v, 16, 16);
    } 
    int scrollbarPos = (int)(128.0F * this.scrollOffs);
    gfx.m_280218_(TEXTURES, 220, 18 + scrollbarPos, 244, 173 + (isScrollBarActive() ? 0 : 15), 12, 15);
    EnchantmentDataWrapper hover = getHovered(pMouseX, pMouseY);
    int j;
    for (j = 0; j < 11 && 
      this.enchantments.size() - 1 >= j; j++) {
      int v = 173;
      EnchantmentDataWrapper data = this.enchantments.get(this.startIndex + j);
      if (data.isBlacklisted) {
        v += 26;
      } else if (hover == this.enchantments.get(this.startIndex + j)) {
        v += 13;
      } 
      gfx.m_280218_(TEXTURES, 89, 18 + 13 * j, 96, v, 128, 13);
    } 
    for (j = 0; j < 11 && 
      this.enchantments.size() - 1 >= j; j++) {
      EnchantmentDataWrapper data = this.enchantments.get(this.startIndex + j);
      if (data.isBlacklisted) {
        gfx.m_280614_(this.f_96547_, (Component)Component.m_237115_(data.getEnch().m_44704_()).m_130938_(s -> s.m_178520_(5812428).m_178522_(Boolean.valueOf(true))), 91, 21 + 13 * j, 16777088, false);
      } else {
        gfx.m_280056_(this.f_96547_, I18n.m_118938_(data.getEnch().m_44704_(), new Object[0]), 91, 21 + 13 * j, 16777088, false);
      } 
    } 
    List<Component> list = new ArrayList<>();
    ApothEnchantmentMenu.Arcana a = ApothEnchantmentMenu.Arcana.getForThreshold((this.parent.getMenu()).stats.arcana());
    list.add(Component.m_237115_("info.apotheosis.weights").m_130944_(new ChatFormatting[] { ChatFormatting.UNDERLINE, ChatFormatting.YELLOW }));
    list.add(Component.m_237110_("info.apotheosis.weight", new Object[] { I18n.m_118938_("rarity.enchantment.common", new Object[0]), Integer.valueOf(a.rarities[0]) }).m_130940_(ChatFormatting.GRAY));
    list.add(Component.m_237110_("info.apotheosis.weight", new Object[] { I18n.m_118938_("rarity.enchantment.uncommon", new Object[0]), Integer.valueOf(a.rarities[1]) }).m_130940_(ChatFormatting.GREEN));
    list.add(Component.m_237110_("info.apotheosis.weight", new Object[] { I18n.m_118938_("rarity.enchantment.rare", new Object[0]), Integer.valueOf(a.rarities[2]) }).m_130940_(ChatFormatting.BLUE));
    list.add(Component.m_237110_("info.apotheosis.weight", new Object[] { I18n.m_118938_("rarity.enchantment.very_rare", new Object[0]), Integer.valueOf(a.rarities[3]) }).m_130940_(ChatFormatting.GOLD));
    gfx.m_280666_(this.f_96547_, list, (a == ApothEnchantmentMenu.Arcana.MAX) ? -2 : 1, 120);
    gfx.m_280614_(this.f_96547_, this.f_96539_, 7, 4, 4210752, false);
    pose.m_85849_();
    pose.m_252880_(0.0F, 0.0F, 10.0F);
    for (int k = 0; k < 3; k++) {
      if (isHovering(8, 18 + 19 * k, 18, 18, pMouseX, pMouseY)) {
        list.clear();
        list.add(Component.m_237110_("info.apotheosis.enchinfo_slot", new Object[] { Integer.valueOf(k + 1) }).m_130944_(new ChatFormatting[] { ChatFormatting.GOLD, ChatFormatting.UNDERLINE }));
        list.add(Component.m_237110_("info.apotheosis.enchinfo_level", new Object[] { Integer.valueOf(this.costs[k]) }).m_130940_(ChatFormatting.GREEN));
        list.add(Component.m_237110_("info.apotheosis.enchinfo_minpow", new Object[] { Integer.valueOf(this.powers[k][0]) }).m_130940_(ChatFormatting.DARK_RED));
        list.add(Component.m_237110_("info.apotheosis.enchinfo_maxpow", new Object[] { Integer.valueOf(this.powers[k][1]) }).m_130940_(ChatFormatting.BLUE));
        gfx.m_280666_(this.f_96547_, list, pMouseX, pMouseY);
      } 
    } 
    if (hover != null) {
      list.clear();
      list.add(Component.m_237115_(hover.getEnch().m_44704_()).m_130944_(new ChatFormatting[] { getColor(hover.getEnch()), ChatFormatting.UNDERLINE }));
      list.add(Component.m_237110_("info.apotheosis.enchinfo_level", new Object[] { Component.m_237115_("enchantment.level." + hover.getLevel()) }).m_130940_(ChatFormatting.DARK_AQUA));
      MutableComponent mutableComponent = Component.m_237115_("rarity.enchantment." + hover.getEnch().m_44699_().name().toLowerCase(Locale.ROOT)).m_130940_(colors[hover.getEnch().m_44699_().ordinal()]);
      list.add(Component.m_237110_("info.apotheosis.enchinfo_rarity", new Object[] { mutableComponent }).m_130940_(ChatFormatting.DARK_AQUA));
      list.add(Component.m_237110_("info.apotheosis.enchinfo_chance", new Object[] { String.format("%.2f", new Object[] { Float.valueOf(100.0F * hover.m_142631_().m_146281_() / WeightedRandom.m_146312_(this.enchantments)) }) + "%" }).m_130940_(ChatFormatting.DARK_AQUA));
      if (I18n.m_118936_(hover.getEnch().m_44704_() + ".desc"))
        list.add(Component.m_237115_(hover.getEnch().m_44704_() + ".desc").m_130940_(ChatFormatting.DARK_AQUA)); 
      List<Enchantment> excls = this.exclusions.get(hover.getEnch());
      if (!excls.isEmpty()) {
        StringBuilder sb = new StringBuilder();
        for (int m = 0; m < excls.size(); m++) {
          sb.append(I18n.m_118938_(((Enchantment)excls.get(m)).m_44704_(), new Object[0]));
          if (m != excls.size() - 1)
            sb.append(", "); 
        } 
        list.add(Component.m_237110_("Exclusive With: %s", new Object[] { sb.toString() }).m_130940_(ChatFormatting.RED));
      } 
      gfx.m_280666_(this.f_96547_, list, pMouseX, pMouseY);
    } 
    gfx.m_280203_(this.toEnchant, this.leftPos + 49, this.topPos + 39);
    pose.m_252880_(0.0F, 0.0F, -10.0F);
    super.m_88315_(gfx, pMouseX, pMouseY, pPartialTick);
  }
  
  public boolean m_6375_(double pMouseX, double pMouseY, int pButton) {
    this.scrolling = false;
    int left = this.leftPos + 220;
    int top = this.topPos + 18;
    if (pMouseX >= left && pMouseX < (left + 12) && pMouseY >= top && pMouseY < (top + 143)) {
      this.scrolling = true;
      m_7979_(pMouseX, pMouseY, 0, pMouseX, pMouseY);
    } 
    for (int i = 0; i < 3; i++) {
      Enchantment clue = Enchantment.m_44697_(this.clues[i]);
      if (this.selectedSlot != i && clue != null && isHovering(8, 18 + 19 * i, 18, 18, pMouseX, pMouseY)) {
        this.selectedSlot = i;
        this.slider.setValue((this.slider.min() + this.slider.max()) / 2);
        Minecraft.m_91087_().m_91106_().m_120367_((SoundInstance)SimpleSoundInstance.m_263171_((Holder)SoundEvents.f_12490_, 1.0F));
        return true;
      } 
    } 
    return super.m_6375_(pMouseX, pMouseY, pButton);
  }
  
  public boolean m_7979_(double pMouseX, double pMouseY, int pButton, double pDragX, double pDragY) {
    if (this.scrolling && isScrollBarActive()) {
      int i = this.topPos + 18;
      int j = i + 143;
      this.scrollOffs = ((float)pMouseY - i - 7.5F) / ((j - i) - 15.0F);
      this.scrollOffs = Mth.m_14036_(this.scrollOffs, 0.0F, 1.0F);
      this.startIndex = (int)((this.scrollOffs * getOffscreenRows()) + 0.5D);
      return true;
    } 
    return super.m_7979_(pMouseX, pMouseY, pButton, pDragX, pDragY);
  }
  
  public boolean m_6050_(double pMouseX, double pMouseY, double pDelta) {
    if (isScrollBarActive()) {
      int i = getOffscreenRows();
      this.scrollOffs = (float)(this.scrollOffs - pDelta / i);
      this.scrollOffs = Mth.m_14036_(this.scrollOffs, 0.0F, 1.0F);
      this.startIndex = (int)((this.scrollOffs * i) + 0.5D);
    } 
    return true;
  }
  
  private boolean isScrollBarActive() {
    return (this.enchantments.size() > 11);
  }
  
  protected int getOffscreenRows() {
    return this.enchantments.size() - 11;
  }
  
  protected boolean isHovering(int pX, int pY, int pWidth, int pHeight, double pMouseX, double pMouseY) {
    int i = this.leftPos;
    int j = this.topPos;
    pMouseX -= i;
    pMouseY -= j;
    return (pMouseX >= (pX - 1) && pMouseX < (pX + pWidth + 1) && pMouseY >= (pY - 1) && pMouseY < (pY + pHeight + 1));
  }
  
  protected void recomputeEnchantments() {
    ApothEnchantmentMenu.Arcana arc = ApothEnchantmentMenu.Arcana.getForThreshold((this.parent.getMenu()).stats.arcana());
    Set<Enchantment> blacklist = (this.parent.getMenu()).stats.blacklist();
    this


      
      .enchantments = (List<EnchantmentDataWrapper>)RealEnchantmentHelper.getAvailableEnchantmentResults(this.currentPower, this.toEnchant, this.treasure, Collections.emptySet()).stream().map(e -> new RealEnchantmentHelper.ArcanaEnchantmentData(arc, e)).map(a -> new EnchantmentDataWrapper(a, blacklist.contains(a.data.f_44947_))).collect(Collectors.toList());
    if (this.startIndex + 11 >= this.enchantments.size()) {
      this.startIndex = 0;
      this.scrollOffs = 0.0F;
    } 
    this.exclusions.clear();
    for (EnchantmentDataWrapper d : this.enchantments) {
      if (blacklist.contains(d.getEnch()))
        continue; 
      List<Enchantment> excls = new ArrayList<>();
      for (EnchantmentDataWrapper d2 : this.enchantments) {
        if (d != d2 && !d.getEnch().m_44695_(d2.getEnch()))
          excls.add(d2.getEnch()); 
      } 
      this.exclusions.put(d.getEnch(), excls);
    } 
  }
  
  public boolean m_7043_() {
    return false;
  }
  
  protected EnchantmentDataWrapper getHovered(double mouseX, double mouseY) {
    for (int i = 0; i < 11 && 
      this.enchantments.size() - 1 >= i; i++) {
      if (isHovering(89, 18 + i * 13, 128, 13, mouseX, mouseY)) {
        EnchantmentDataWrapper data = this.enchantments.get(this.startIndex + i);
        return data.isBlacklisted ? null : data;
      } 
    } 
    return null;
  }
  
  public static ChatFormatting getColor(Enchantment ench) {
    return EnchModule.getEnchInfo(ench).isTreasure() ? ChatFormatting.GOLD : ChatFormatting.GREEN;
  }
}
